% Nastaveni:
n = 600;               % rozmer sachovnice, na ktere se namornik pohybuje
pocet_kroku = 10000;   % kolik kroku ma namornik udelat

% Program:
a = zeros(n,n);        % pocitadlo vyskytu namornika na jednotlivych polickach
r = floor(n/2);  c = floor(n/2);  % vychozi misto

a(r,c) = 1;            % namornik se na zacatku nachazi pred hospodou
for k=1:pocet_kroku
    delta = 2*(randi(2,1,2)-1) - 1;  % mapuj nahodna cisla [1,2] na [-1, +1]
    r = r + delta(1);  % posun se nahoru nebo dolu
    c = c + delta(2);  % posun se doleva nebo doprava
    if (r==0 || r==n+1) break; end  % namornik dorazil na kraj sachovnice
    if (c==0 || c==n+1) break; end
    a(r,c) = a(r,c) + 1;  % byl jsem tu
    fprintf('%3i. delta= %2i %2i  rc= %2i %2i\n', k, delta(1), delta(2), r, c);
    if (mod(k,1000)==0)   % kazdych 1000 iteraci vykresli obrazek
        k, imagesc(a); colorbar; pause(0.01);  % kratka pauza pro prekresleni
    end
end
colormap(rainbow(max(a(:))+1));
imagesc(a); colorbar

